<template>
  <div class="ob-order-route-card-container">
    <template v-if="trips && trips.length > 1 && !selectedTrip">
      <div :data-qa="dataQa"
           class="ob-order-route-multicard"
      >
        <div class="services-list card-list">
          <div
            v-if="services.length"
            class="card-list-item"
          >
            <div class="card-list-container">
              <div class="location-address location-simple-title">
                Общие услуги
              </div>
              <div
                v-for="(service, index) in services"
                :key="service.uuid"
                class="service-item"
                :style="{
                  left: (346 + (index * 100)) + 'px',
                  zIndex: 100 - index
                }"
              >
                <div class="service-item__top">
                  <div class="desc">
                    <div class="desc__title">
                      {{ service.typeTitle }}
                    </div>
                    <div class="desc__icon">
                      <OrderIconByStatus
                        :status="service.status"
                      />
                    </div>
                  </div>
                  <div
                    :title="service.contractorTitle || ''"
                    class="info"
                  >
                    <template v-if="service.contractorTitle">
                      {{ service.contractorTitle }}
                    </template>
                    <template v-else>
                      Назначение
                    </template>
                  </div>
                </div>
                <div
                  :class="!['NEW', 'DRAFT', 'ON_DOER_SEARCH', 'CANCELED'].includes(service.status) && '--active'"
                  class="service-item__point"
                />
                <div class="service-item__bottom">
                  {{ service.resourceNumber }}
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="card-list">
          <div v-for="(item, pointIndex) in value.items"
               :key="item.uuid"
               class="card-list-item"
               :class="{ done: item.done }"
          >
            <div class="card-list-container"
            >
              <div class="location-address">
                <div class="location-head">
                  <span class="icon pin" />
                  <div class="location-head__title" :title="item.pointName">
                    {{ item.pointName }}
                  </div>
                </div>
                <div class="location-text" :title="item.pointAddress">
                  {{ item.pointAddress }}
                </div>
              </div>
              <div
                v-for="(trip, index) in getTripsByPoint(item)"
                :key="trip.uuid"
                class="mapper-wrapper"
                :style="{
                  left: (340 + (index * 100)) + 'px',
                  zIndex: 100 - pointIndex
                }"
              >
                <div
                  v-if="pointIndex !== 0"
                  class="dashed-line"
                >
<!--                  <div class="dop-radio-mapper">-->
<!--                    <i class="icon sort"></i>-->
<!--                  </div>-->
                </div>
                <TabComponent
                  v-if="pointIndex === 0"
                  :key="item.uuid"
                  :data-source="trip"
                />
                <div
                  v-if="item.point == 'from'"
                  class="radio-mapper from"
                >
                  <i class="icon route-loading"/>
                </div>
                <div
                  v-else-if="item.point == 'to'"
                  class="radio-mapper to"
                >
                  <i class="icon route-unloading"/>
                </div>
                <div
                  v-else
                  class="radio-mapper"
                >
                  <i class="icon sort"></i>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </template>
    <template v-else>
      <div
        :data-qa="dataQa"
        class="ob-order-route-card"
      >
        <div class="card-title">
          Маршрут <span>{{ value.pointFrom }}</span> → <span>{{ value.pointTo }}</span>
        </div>
        <div
            class="card-list"
        >
          <div
            v-for="(item, index) in value.items"
            :key="item.uuid"
            class="card-list-item"
            :class="{
              done: item.done,
              'history-log': item.type == 'log',
              location: item.type == 'location',
              state: item.type == 'state'
            }"
          >
            <div
              v-if="item.type == 'log'"
              class="card-list-container"
            >
              <div class="history-log-time">
                {{ item.time }}<br>
                {{ item.date }}
              </div>
              <div class="history-log-type">
                {{ item.status }}
              </div>
              <div class="history-log-message">
                {{ item.message }}
              </div>
              <div class="radio-mapper" />
            </div>
            <div
              v-if="item.type == 'location'"
              class="card-list-container f-d-c"
              :class="{
                '--active': Boolean(getPointInfo(item).factSlotStartAt) && Boolean(getPointInfo(item).factSlotEndAt),
                '--current': Boolean(getPointInfo(item).factSlotStartAt) && !Boolean(getPointInfo(item).factSlotEndAt)
              }"
            >
              <div class="d-f">
                <div class="location-address">
                  <div
                    class="location-head"
                    :class="[ isClicar && isEditableLocation && 'cp' ]"
                    @click="isClicar && isEditableLocation && onProcessChangeLocation(item, index)"
                  >
                    <span class="icon pin" />
                    <div class="location-head__title" :title="item.pointName">
                      {{ item.pointName }}
                    </div>
                    <div class="location-head__edit">
                      <i
                        v-if="isClicar && isEditableLocation"
                        class="icon edit edit-slot-icon"
                      />
                    </div>
                  </div>
                  <div class="location-text">
                    {{ item.pointAddress }}
                  </div>
                </div>
                <div
                  class="location-slot"
                  :class="[ (isClicar || (isClient && selectedTrip)) && isEditableSlot(item) && 'cp' ]"
                  @click="(isClicar || (isClient && selectedTrip)) && isEditableSlot(item) && onProcessChangeSlot(item, index)"
                >
                  <div class="location-block-header">Слот</div>
                  <div class="location-slot__time">
                    <span>{{ item.dateStart | date('HH:mm') }}</span>
                    <span>{{ item.dateEnd | date('HH:mm') }}</span>
                  </div>
                  <div class="location-slot__date">
                    <div class="location-slot__date-edit">
                      <i
                        v-if="(isClicar || (isClient && selectedTrip)) && isEditableSlot(item)"
                        class="icon edit edit-slot-icon"
                      />
                    </div>
                    <span>{{ item.dateStart | date('DD.MM.YY (ddd)') }}</span>
                  </div>
                </div>

                <template v-if="pointsInfo">
                  <template v-if="getPointInfo(item).factSlotStartAt">
                    <div
                        class="location-fact-slot"
                    >
                      <div class="location-block-header">Прибытие</div>
                      <div class="location-fact-slot__time">
                        <span>{{ getPointInfo(item).factSlotStartAt | date('HH:mm') }}</span>
                        <FactSlotIcon
                          :point="getPointInfo(item)"
                          property="factSlotStartUpdatedBy"
                        />
                      </div>
                      <div class="location-fact-slot__date">
                        <span>{{ getPointInfo(item).factSlotStartAt | date('DD.MM.YY') }}</span>
                      </div>
                    </div>
                    <div
                      class="location-fact-slot"
                    >
                      <div class="location-block-header">начало пРР</div>
                      <template v-if="getPointInfo(item).prrStartAt">
                        <div class="location-fact-slot__time">
                          <span>{{ getPointInfo(item).prrStartAt | date('HH:mm') }}</span>
                        </div>
                        <div class="location-fact-slot__date">
                          <span>{{ getPointInfo(item).prrStartAt | date('DD.MM.YY') }}</span>
                        </div>
                      </template>
                      <template v-else>
                        <template v-if="isClicar && !isCancelledOrder && order.isEditable">
                          <button
                              class="location-fact-slot__button"
                              @click="addPointEvent({ code: 'cargo_handling_started', point: item })"
                          >
                            Добавить
                          </button>
                        </template>
                        <template v-else>
                          <div class="location-fact-slot__time">
                            --
                          </div>
                        </template>
                      </template>
                    </div>
                    <div
                        class="location-fact-slot"
                    >
                      <div class="location-block-header">оконч. ПРР</div>
                      <template v-if="getPointInfo(item).prrEndAt">
                        <div class="location-fact-slot__time">
                          <span>{{ getPointInfo(item).prrEndAt | date('HH:mm') }}</span>
                        </div>
                        <div class="location-fact-slot__date">
                          <span>{{ getPointInfo(item).prrEndAt | date('DD.MM.YY') }}</span>
                        </div>
                      </template>
                      <template v-else>
                        <template v-if="isClicar && !isCancelledOrder && order.isEditable">
                          <button
                              class="location-fact-slot__button"
                              @click="addPointEvent({ code: 'cargo_handling_ended', point: item })"
                          >
                            Добавить
                          </button>
                        </template>
                        <template v-else>
                          <div class="location-fact-slot__time">
                            --
                          </div>
                        </template>
                      </template>
                    </div>
                    <div
                        class="location-fact-slot"
                    >
                      <div class="location-block-header">Убытие</div>
                      <template v-if="getPointInfo(item).factSlotEndAt">
                        <div class="location-fact-slot__time">
                          <span>{{ getPointInfo(item).factSlotEndAt | date('HH:mm') }}</span>
                          <FactSlotIcon
                            :point="getPointInfo(item)"
                            property="factSlotEndUpdatedBy"
                          />
                        </div>
                        <div class="location-fact-slot__date">
                          <span>{{ getPointInfo(item).factSlotEndAt | date('DD.MM.YY') }}</span>
                        </div>
                      </template>
                      <template v-else>
                        <div class="location-fact-slot__status">Ожидание убытия</div>
                      </template>
                    </div>
                  </template>
                  <template v-else>
                    <div class="location-none-fact">Ожидание прибытия</div>
                  </template>
                </template>

                <div class="location-events-menu">
                  <ObMenuDropdown
                    v-if="isClicar && order.isEditable"
                    :items="dropdownMenu(item)"
                    :is-none-button-style="true"
                  >
                    <div
                      class="d-f al-i-c"
                      slot="button"
                    >
                      <i class="icon plus" />
                      <span>Событие</span>
                    </div>
                  </ObMenuDropdown>
                </div>

                <div
                    v-if="item.point == 'from'"
                    class="radio-mapper from"
                >
                  <i class="icon route-loading" />
                </div>
                <div
                    v-if="item.point == 'to'"
                    class="radio-mapper to"
                >
                  <i class="icon route-unloading" />
                </div>
              </div>
              <div class="d-f consignor-status-error" v-if="item.consignorStatus === 'ABSENT' || item.consignorStatus === 'ERROR_WHILE_ADDING'">
                <i class="icon info"></i>
                {{ getConsignorStatusErrorText(item.consignorStatus) }}
              </div>
              <div
                v-if="item.comments"
                class="location-comment"
              >
                <i class="icon comment" />
                <div>
                  {{ item.comments }}
                </div>
              </div>
              <OrderEvents
                v-if="getPointEvents(item.visitPointUuid || item.uuid).length"
                class="location-events"
                :events="getPointEvents(item.visitPointUuid || item.uuid)"
                :order="order"
                :points-info="pointsInfo"
              />
            </div>
            <div
              v-if="item.type == 'state'"
              class="card-list-container"
            >
              <div>
                {{ item.message }}
              </div>
              <div class="radio-mapper" />
            </div>
          </div>
        </div>
      </div>
    </template>
    <ob-modal
      ref="changeSlot"
      :title="'Изменение слота'"
      size="medium"
      :is-show-controls="false"
      data-qa="changeSlotModal"
      @cancel="onCancelChangeSlot"
    >
      <ChangeSlotModal
        :prev-point="prevPoint"
        :points="points"
        :dataSource="selectedPoint"
        @submit="onChangeSlot"
      />
    </ob-modal>
    <EventModal
      ref="eventModal"
      :data-source="eventData"
      :order="order"
      @created="updatePointsInfo"
      @consignor-changed="updateSubOrders"
      @consignee-changed="updateSubOrders"
    />
  </div>
</template>

<script>
import api from '@/api'
import { mapGetters, mapActions } from 'vuex'
import ObModal from 'common-components/src/obComponents/obModal'
import ObMenuDropdown from 'common-components/src/obComponents/obMenuDropdown'
import TabComponent from './TabComponent.vue'
import OrderIconByStatus from '@/components/Order/orderItem/execution/OrderIconByStatus'
import ChangeSlotModal from '@/components/Order/modal/ChangeSlotModal'
import EventModal from '@/components/Order/orderItem/execution/events/modal'
import FactSlotIcon from '@/components/Order/orderItem/execution/factSlotUpdatedByIcon'
import OrderEvents from '@/components/Order/orderItem/execution/events/OrderEvents'
import moment from 'moment'

export default {
  name: 'OrderRouteDiagram',
  components: {
    TabComponent,
    OrderIconByStatus,
    FactSlotIcon,
    ChangeSlotModal,
    EventModal,
    OrderEvents,
    ObModal,
    ObMenuDropdown
  },
  props: {
    value: {
      type: [Object],
      default: () => {
        return {
          pointFrom: '',
          pointTo: '',
          items: []
        }
      },
    },
    order: {
      type: Object,
      default: () => {}
    },
    trips: {
      type: Array,
      default: () => []
    },
    events: {
      type: Array,
      default: () => []
    },
    dataQa: {
      type: String
    },
    pointsInfo: {
      type: Object,
      default: null
    }
  },
  data () {
    return {
      currentTrips: {},
      selectedPoint: {},
      eventData: {}
    }
  },
  computed: {
    ...mapGetters({
      selectedTrip: 'order/selectedTrip',
      isClicar: 'user/isClicar',
      isClient: 'user/isClient'
    }),
    services () {
      return this.trips.filter((item) => {
        return item.mainType === 'logchainOrderService'
      })
    },
    points () {
      return this.value?.items || []
    },
    prevPoint () {
      const currentIndex = this.selectedPoint && this.selectedPoint.index

      return this.points.length && currentIndex >= 0 && this.points[currentIndex - 1] ? this.points[currentIndex - 1] : null
    },
    isCancelledOrder () {
      return this.order.status === 'CANCELED'
    },
    isEditableLocation () {
      return this.isClicar && this.order.isSuborder && ['NEW', 'ON_DOER_SEARCH', 'BOOKED', 'ALLOCATED', 'CONTRACTED', 'IN_PROCESS', 'PROCESSED'].includes(this.order.status) && this.order.isEditable
    }
  },
  watch: {
    trips: {
      immediate: true,
      handler (value) {
        let currentTrips = {}
        value && value.items && value.items.forEach((point) => {
          currentTrips[point.uuid] = value.filter((trip) => {
            return trip.shipmentPoints && trip.shipmentPoints.find(item => item.visitPointUuid === point.uuid) && trip.mainType === 'order'
          })
        })
        this.currentTrips = currentTrips
      }
    }
  },
  methods: {
    ...mapActions({
      updateSubOrders: 'order/updateSubOrders',
      getTripPointsInfo: 'order/getTripPointsInfo',
      getTripEvents: 'order/getTripEvents',
      getReasonsList: 'order/getReasonsList'
    }),
    getConsignorStatusErrorText(status) {
      const errorsMap = {
        ABSENT: 'ГО не добавлен в ЭТП ГП',
        ERROR_WHILE_ADDING: 'ГО не зарегистрирован в ЭТП'
      }
      return errorsMap[status];
    },
    getTripsByPoint (point) {
      return this.currentTrips[point.uuid] || []
    },
    onProcessChangeSlot (point, index) {
      this.selectedPoint = { ...point, index }
      this.$refs.changeSlot.open()
    },
    async onProcessChangeLocation (point) {
      try {
        const type = point.point === 'from' ? 'CONSIGNOR' : 'CONSIGNEE'
        const orderKey = point.point === 'from' ? 'consignors' : 'consignees'
        const consigneeOrConsignorUuid = this.order[orderKey].find(item => item.title === point.title)?.uuid
        const ownerUuid = this.order.cargoOwnerUuid
        let inn
        if (consigneeOrConsignorUuid) {
          try {
            let res = await api.orderProcess.getConsignorsConsigneesInfo({
              uuid: consigneeOrConsignorUuid,
              ownerUuid
            })
            inn = res.inn
          } catch {
            this.$notification({
              type: 'system_notification_error',
              message: 'Ошибка загрузки данных'
            })
          }
        }

        this.eventData = { point, consigneeOrConsignorUuid, inn, code: type + '_CHANGED' }
        this.$refs.eventModal.open()
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        })
      }
    },
    onCancelChangeSlot () {
      this.selectedPoint = {}
    },
    onChangeSlot () {
      this.$refs.changeSlot.close()
      this.updateSubOrders()
    },
    isEditableSlot (data) {
      return !this.isCancelledOrder && data.plannedSlotStartAt && moment(data.plannedSlotStartAt).diff(moment()) > 0
    },
    getPointInfo ({ visitPointUuid }) {
      if (!this.pointsInfo) return {}

      return this.pointsInfo[visitPointUuid] || {}
    },
    addPointEvent (data) {
      data.point.prrStartAt = this.getPointInfo({ visitPointUuid: data.point.visitPointUuid }).prrStartAt
      this.eventData = data
      this.$refs.eventModal.open()
    },
    updatePointsInfo () {
      this.getTripPointsInfo({ uuid: this.order.tripUuid })
      if (this.selectedTrip) {
        const { uuid, tripUuid } = this.selectedTrip
        this.getTripEvents({
          uuid: tripUuid,
          suborderUuid: uuid
        })
      }
    },
    getPointEvents (uuid) {
      return this.events.filter(item => item.visitPointUuid && item.visitPointUuid === uuid)
    },
    dropdownMenu (point) {
      if (!this.order.isSuborder || !this.isClicar || !this.selectedTrip || this.isCancelledOrder) return null

      let events = this.getPointEvents(point.visitPointUuid)
      let pointInfo = this.getPointInfo(point)

      return [
        {
          title: 'Опоздание',
          code: 'ARRIVING_DELAY',
          method: (data) => this.createEvent(data.code, point),
          isHidden: !pointInfo.factSlotStartAt || events.find(event => event.eventTypeCode === 'ARRIVING_DELAY') || !['IN_PROCESS', 'PROCESSED', 'EXECUTION_CONFIRMED', 'INVOICING', 'INVOICED', 'PAY_PROCESS', 'PAID'].includes(this.order.status)
        }
      ]
    },
    async createEvent (code, point = {}) {
      this.eventData = {
        code,
        point
      }

      if (code === 'ARRIVING_DELAY') {
        await this.getReasonsList({ code })
      }

      this.$refs.eventModal.open()
    }
  }
}
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .edit-slot-icon {
    margin-left: 10px;
    color: $color-blue-navy-blue;
    font-size: 16px;
    opacity: 0;
    .location-slot:hover &, .location-head:hover & {
      opacity: 1;
    }
  }

  .cp {
    cursor: pointer;
  }

  .route-loading {
    color: $diamond-orange-yellow;
  }

  .route-unloading {
    color: $Green-700;
  }

  .services-list {
    margin-bottom: 40px;
    .location-simple-title {
      padding: 7px 0;
      @include font-mixin(16px, 20px, 400, $color-text-base, 0.2px);
    }
    .service-item {
      z-index: 10;
      position: absolute;
      top: calc(50% - 7px);
      &__top, &__bottom {
        position: absolute;
        left: 50%;
        width: 82px;
        transform: translateX(-50%);
        text-align: center;
      }
      &__top {
        top: -50px;
        .desc {
          display: flex;
          align-items: center;
          justify-content: center;
          &__title {
            @include font-mixin(8px, 10px, 400, rgba(0, 112, 166, 0.5), 0.1px, uppercase);
          }
          &__icon {
            display: flex;
            align-items: center;
            margin-left: 5px;
          }
        }
        .info {
          min-height: 20px;
          max-width: 93px;
          white-space: nowrap;
          overflow: hidden;
          text-overflow: ellipsis;
          @include font-mixin(10.5px, 20px, 400, rgba(0, 112, 166, 0.5), 0.4px, uppercase);
        }
      }
      &__point {
        width: 16px;
        height: 16px;
        border: 1px solid $color-grey-border;
        background-color: $background-white;
        border-radius: 50%;
        &.--active {
          border-color: rgba(0, 112, 166, 0.5);
          border-width: 2px;
        }
      }
      &__bottom {
        bottom: -20px;
        @include font-mixin(9.5px, 10px, 400, rgba(0, 112, 166, 0.5), 0.1px, uppercase);
      }
    }
  }
  .ob-order-route-card {
    background-color: $background-white;
    .card-title {
      font-weight: bold;
      font-size: 20px;
      line-height: 28px;
    }
    .card-list {
      margin-left: 30px;
      margin-top: 15px;
      border-left: 2px dashed $color-grey-border;
      .card-list-item {
        padding: 15px 0 15px 41px;
        position: relative;
        &.done {
          &:before {
            content: '';
            position: absolute;
            display: block;
            top: 0px;
            left: -2px;
            width: 2px;
            height: 100%;
            background: $color-blue-navy-blue;
            z-index: 1;
          }
          .radio-mapper {
            border: 2px solid $color-blue-navy-blue;
          }
        }
        &:first-child {
          &:after {
            content: '';
            position: absolute;
            display: block;
            top: 0px;
            left: -2px;
            width: 2px;
            height: 50%;
            background: $background-white;
            z-index: 2;
          }
        }
        &:last-child {
          &:after {
            content: '';
            position: absolute;
            display: block;
            bottom: 0px;
            left: -2px;
            width: 2px;
            height: 50%;
            background: $background-white;
            z-index: 2;
          }
        }
        .radio-mapper {
          position: absolute;
          width: 16px;
          height: 16px;
          border: 1px solid $color-grey-border;
          background-color: $background-white;
          border-radius: 50%;
          top: 0;
          bottom: 0;
          left: -9px;
          margin: auto;
        }
        .item-icon {
          background-repeat: no-repeat;
          background-size: contain;
          background-position: center;
          display: inline-block;
          vertical-align: middle;
        }
        .card-list-container {
          border-radius: 3px;
        }
        &.history-log {
          .card-list-container {
            background: $light-lavender;
            padding: 3px 20px;
            letter-spacing: 0.4px;
            text-transform: uppercase;
            font-variant: small-caps;
            font-size: 12px;
            line-height: 18px;
            min-height: 40px;
            .history-log-time {
              color: $color-grey-span;
              float: left;
              width: 65px;
              line-height: 18px;
            }
            .history-log-message {
              color: $color-text-base;
              margin: 0 144px 0 65px;
              padding: 10px 20px 5px 50px;
            }
            .history-log-type {
              padding: 10px;
              color: $color-grey-span;
              float: right;
              width: 144px;
            }
          }
        }
        &.history-log + .history-log {
          padding-top: 0;
          margin-top: -10px;
          :not(.current) {
            .radio-mapper {
              display: none;
            }
          }
        }
        &.location {
          .card-list-container {
            display: flex;
            padding: 20px;
            background: $background-white;
            border: 1px solid $lavender;
            box-shadow: 0px 2px 7px rgba($color-blue-navy-blue, 0.1);
            min-height: 104px;
            font-size: 12px;
            line-height: 18px;
            &.--active {
              border: 2px solid #80B7D2;
              .radio-mapper {
                border: 2px solid #80B7D2;
              }
            }
            &.--current {
              border: 2px solid #0070A6;
              .radio-mapper {
                border: 2px solid #0070A6;
              }
            }
            .radio-mapper {
              height: 30px;
              width: 30px;
              left: -16px;
              background-size: 10px 20px;
              background-position: center;
              background-repeat: no-repeat;
              display: flex;
              justify-content: center;
              align-items: center;
              &.from {
                .icon {
                  color: $diamond-orange-yellow;
                  font-size: 14px;
                }
              }
              &.to {
                .icon {
                  color: $Green-700;
                  font-size: 14px;
                }
              }
            }
            .location-head {
              display: flex;
              font-size: 16px;
              line-height: 20px;
              letter-spacing: 0.2px;
              color: $color-text-base;
              margin-bottom: 6px;
              font-weight: normal;
              &__title {
                margin-top: 4px;
                max-height: 36px;
                overflow: hidden;
                white-space: nowrap;
                text-overflow: ellipsis;
              }
              &__edit {
                display: flex;
                align-items: center;
                .edit-slot-icon {
                  font-size: 18px!important;
                }
              }
            }
            .location-text {
              text-transform: none;
              font-variant: none;
              padding-left: 31px;
              color: $color-grey-span;
              font-size: 12px;
              line-height: 16px;
              letter-spacing: 0.4px;
            }
            .location-address {
              width: 290px;
              margin-right: 20px;
              .icon {
                color: $color-blue-navy-blue;
                font-size: 25px;
                margin-right: 6px;
                vertical-align: middle;
              }
            }
            .location-block-header {
              position: absolute;
              top: -43px;
              left: 0;
              @include font-mixin(9px, 11px, 400, $color-grey-label, 0.6px, uppercase);
            }
            .location-slot {
              position: relative;
              display: flex;
              margin-top: 3px;
              margin-right: 21.5px;
              &__time {
                display: flex;
                flex-direction: column;
                @include font-mixin(16px, 20px, 400);
                span + span {
                  margin-top: 5px;
                }
              }
              &__date {
                display: flex;
                flex-direction: column;
                margin-left: 10px;
                &-edit {
                  display: flex;
                  align-items: center;
                  height: 20px;
                  margin-bottom: 5px;
                }
                span {
                  @include font-mixin(12px, 20px, 400, $color-grey-label);
                }
              }
            }
            .location-fact-slot {
              position: relative;
              width: 90px;
              height: 45px;
              display: flex;
              flex-direction: column;
              margin-top: 3px;
              padding-left: 12.5px;
              padding-right: 12.5px;
              border-left: 1px solid $color-grey-border;
              &__time {
                position: relative;
                @include font-mixin(16px, 18px, 400);
                &::v-deep {
                  .fact-slot-update-by-icon {
                    position: absolute;
                    top: 0;
                    right: -3px;
                  }
                }
              }
              &__date {
                margin-top: 12px;
                @include font-mixin(10px, 12px, 400, $color-grey-label, 0.4px);
              }
              &__status {
                margin-top: 10px;
                text-align: center;
                @include font-mixin(12px, 12px, 400, $color-grey-label, 0.4px);
              }
              &__button {
                margin: 16px 0 0 0;
                padding: 0 5px;
                background-color: transparent;
                border: none;
                outline: none;
                opacity: 0.5;
                @include font-mixin(12px, 12px, 400, $blue-700);
                &:hover {
                  cursor: pointer;
                  opacity: 0.8;
                }
              }
              .location-block-header {
                left: 14.5px;
              }
            }
            .location-none-fact {
              width: 350px;
              height: 44px;
              display: flex;
              align-items: center;
              justify-content: center;
              @include font-mixin(12px, 16px, 400, $color-grey-label, 0.4px);
            }
            .location-events-menu {
              flex-grow: 2;
              display: flex;
              justify-content: flex-end;
            }
            .location-eta {
              flex-grow: 2;
              display: flex;
              flex-wrap: wrap;
              .eta-block {
                width: 33%;
                font-size: 12px;
                line-height: 20px;
                color: $color-grey-span;
                font-variant: small-caps;
                text-transform: uppercase;
                margin-bottom: 5px;
                &.time {
                  position: relative;
                  > span {
                    font-size: 16px;
                    line-height: 20px;
                    letter-spacing: 0.2px;
                    color: $color-text-base;
                  }
                  .eta-caption {
                    position: absolute;
                    top: -43px;
                  }
                }
              }
            }
            .location-works {
              padding-top: 5px;
              .location-work-list {
                display: flex;
                color: $color-grey-span;
                font-variant: small-caps;
                text-transform: uppercase;
                background: $light-lavender;
                border-radius: 3px;
                margin-bottom: 2px;
                padding: 10px 20px;
                .work-time {
                  width: 80px;
                }
                .work-type {
                  width: 70px;
                  line-height: 30px;
                }
                .work-description {
                  flex-grow: 1;
                  .work-title {
                    color: $color-text-base;
                  }
                }
                .work-icon {
                  color: $color-blue-navy-blue;
                  width: 40px;
                  font-size: 20px;
                  line-height: 30px;
                  text-align: right;
                  padding-right: 15px;
                  .icon {
                    vertical-align: middle;
                  }
                }
                .work-personal {
                  width: 150px;
                  .work-title {
                    color: $color-text-base;
                  }
                }
              }
            }
            .location-comment {
              display: flex;
              margin-top: 8px;
              .icon {
                margin-right: 13px;
                font-size: 14px;
                color: $blue-700;
                opacity: 0.5;
              }
              div {
                margin-top: -2px;
                @include font-mixin(12px, 16px, 400, $color-grey-label, 0.2px);
              }
            }
            .location-events {
              margin-top: 20px;
            }
          }
        }
        &.state {
          .card-list-container {
            padding: 15px 20px;
            background: $background-white;
            border: 1px solid $lavender;
            box-shadow: 0px 2px 7px rgba($color-blue-navy-blue, 0.1);
            font-size: 16px;
            line-height: 18px;
            color: $color-text-base;
          }
        }

        &.current {
          &.location {
            .card-list-container {
              border: 2px solid $color-blue-navy-blue;
            }
          }
          &.state {
            .card-list-container {
              border: 2px solid $color-blue-navy-blue;
            }
          }
        }
      }
    }
  }

  .ob-order-route-multicard {
    background-color: $background-white;

    .card-title {
      font-weight: bold;
      font-size: 20px;
      line-height: 28px;
    }

    .card-list {
      margin-left: 30px;
      margin-top: 15px;

      .card-list-item {
        padding: 15px 0 15px 0px;
        position: relative;

        &.done {
          &:before {
            content: '';
            position: absolute;
            display: block;
            top: 0px;
            left: -2px;
            width: 2px;
            height: 100%;
            background: $color-blue-navy-blue;
            z-index: 1;
          }

          .radio-mapper {
            border: 2px solid $color-blue-navy-blue;
          }
        }

        &.current {
          &:before {
            content: '';
            position: absolute;
            display: block;
            top: 0px;
            left: -2px;
            width: 2px;
            height: 50%;
            background: $color-blue-navy-blue;
            z-index: 1;
          }

          .radio-mapper {
            border: 2px solid $color-blue-navy-blue;
          }
        }

        &:first-child {
          &:after {
            content: '';
            position: absolute;
            display: block;
            top: 0px;
            left: -2px;
            width: 2px;
            height: 50%;
            background: $background-white;
            z-index: 2;
          }
        }

        &:last-child {
          &:after {
            content: '';
            position: absolute;
            display: block;
            bottom: 0px;
            left: -2px;
            width: 2px;
            height: 50%;
            background: $background-white;
            z-index: 2;
          }
        }

        .mapper-wrapper {
          position: absolute;
          width: 30px;
          height: 30px;
          top: 50%;
          transform: translateY(-50%);
          z-index: 3;

          .sort {
            color: $color-grey-border;
            font-size: 18px;
          }

          .dashed-line {
            z-index: 100;
            position: absolute;
            width: 1px;
            left: 13px;
            height: 110px;
            top: -100px;
            border-left: 2px dashed $color-grey-border;

            &.none {
              display: none;
            }

            .dop-radio-mapper {
              position: absolute;
              border: 1px solid $color-grey-border;
              background-color: $background-white;
              border-radius: 50%;
              width: 30px;
              height: 30px;
              bottom: -25px;
              left: -15px;
              display: flex;
              align-items: center;
              justify-content: center;
            }
          }

          &::v-deep {
            .order-trip-tab-item {
              display: flex;
              flex-direction: column;
              align-items: center;
              position: absolute;
              width: 82px;
              height: 40px;
              top: -50px;
              left: 50%;
              justify-content: flex-start;
              transform: translateX(-50%);
              margin: 0;
              padding: 0;
              background-color: transparent;
              font-size: 10px;
              cursor: default;
              .top {
                justify-content: center;
              }
              .bottom {
                opacity: 0.5;
              }
            }
          }

          .top-icon {
            position: absolute;
            top: -30px;
            left: 50%;
            transform: translateX(-50%);

            .icon {
              font-size: 18px;
              color: #99B7E9;
            }
          }

          .radio-mapper {
            z-index: 200;
            position: absolute;
            border: 1px solid $color-grey-border;
            background-color: $background-white;
            border-radius: 50%;
            width: 100%;
            height: 100%;
            top: 0;
            left: 0;
            display: flex;
            align-items: center;
            justify-content: center;

          }
        }

        .item-icon {
          background-repeat: no-repeat;
          background-size: contain;
          background-position: center;
          display: inline-block;
          vertical-align: middle;
        }

        .card-list-container {
          display: flex;
          padding: 15px;
          background: $background-white;
          box-shadow: 0px 2px 7px rgba($color-blue-navy-blue, 0.1);
          font-size: 12px;
          line-height: 18px;
          width: 284px;
          border: 1px solid rgba(209, 210, 214, 0.5);
          border-radius: 3px;

          .location-head {
            display: flex;
            font-size: 16px;
            line-height: 20px;
            letter-spacing: 0.2px;
            color: $color-text-base;
            margin-bottom: 6px;
            font-weight: normal;
            &__title {
              margin-top: 4px;
              overflow: hidden;
              white-space: nowrap;
              text-overflow: ellipsis;
            }
          }

          .location-text {
            text-transform: none;
            font-variant: none;
            color: $color-grey-span;
            font-size: 12px;
            line-height: 16px;
            padding-left: 31px;
            height: 32px;
            overflow: hidden;
            letter-spacing: 0.4px;
          }

          .location-address {
            width: 100%;
            .icon {
              color: $color-blue-navy-blue;
              font-size: 25px;
              margin-right: 6px;
              vertical-align: middle;
            }
          }

          &:after {
            content: '';
            position: absolute;
            width: calc(100% - 284px);
            left: 284px;
            top: 50%;
            height: 1px;
            background: $color-grey-border;
          }
        }

        &.history-log {
          .card-list-container {
            background: $light-lavender;
            padding: 3px 20px;
            letter-spacing: 0.4px;
            text-transform: uppercase;
            font-variant: small-caps;
            font-size: 12px;
            line-height: 18px;
            min-height: 40px;

            .history-log-time {
              color: $color-grey-span;
              float: left;
              width: 65px;
              line-height: 18px;
            }

            .history-log-message {
              color: $color-text-base;
              margin: 0 144px 0 65px;
              padding: 10px 20px 5px 50px;
            }

            .history-log-type {
              padding: 10px;
              color: $color-grey-span;
              float: right;
              width: 144px;
            }
          }
        }

        &.history-log + .history-log {
          padding-top: 0;
          margin-top: -10px;

          :not(.current) {
            .radio-mapper {
              display: none;
            }
          }
        }
      }
    }
  }

  .consignor-status-error {
    margin-top: 5px;
    color: $color-error;

    .icon {
      margin-right: 15px;
      font-size: 16px;
      font-weight: 700;
    }
  }
</style>
